<?php
/* $Id: authenticate.php 13 2009-05-05 17:22:34Z mir $ */
require_once 'config.inc.php';
require_once 'persistens.php';

class Authenticate {

    private $valid_user;
    private $settings;
    private $db;
    private $secKey;
    private $pubKey;

    public function __construct($db) {
        $this->valid_user = FALSE;
        $this->settings = array();
        $this->db = $db;
        $this->secKey = NULL;
        $this->pubKey = NULL;
    }

    public function login($uid, $pwd) {
        $con = Persistens::getInstance($this->db);
        $settings = array_change_key_case(
            $con->authenticate($uid, $pwd));
        if (count($settings) == 0) {
            $this->valid_user = FALSE;
        }
        else {
            $setting = array();
            $this->settings = array();
            foreach ($settings as $row) {
                $this->secKey = $row['seckey'];
                $this->pubKey = $row['pubkey'];
                foreach ($row as $key => $val) {
                    if ($key != 'seckey' || $key != 'pubkey')
                        $setting[$key] = $val;
                }
                array_push($this->settings, $setting);
            }
            $this->valid_user = TRUE;
        }
    }

    public function logout() {
        $this->valid_user = false;
        $this->key = NULL;
    }

    public function validUser() {
        return $this->valid_user;
    }

    public function getSettings() {
        return $this->settings;
    }

    public function getSecretKey() {
        return $this->secKey;
    }

    public function getPublicKey() {
        return $this->pubKey;
    }

}
?>
